Win32 App
TestIt
Win32 dialog app
[*BEGINPRO*]
[*BEGINDEF*]
[MakeDef]
Menu=1,1,1,1,1,1,1,1,0,0
1=4,O,$B\GORC.EXE /r=,4,1
2=$.obj,O,$B\NASMW -fobj,$.asm
3=$.exe,O,$B\ALINK -oPE,$.obj,c:\compila\nasmx\lib\win32.lib,TestIt.res
4=0,0,,$.exe
5=TestIt.obj,O,$B\CVTRES,TestIt.res
6=*.obj,O,$B\NASMW -fobj,*.asm
7=0,0,\OllyDbg\OllyDbg,$.exe
11=TestIt.res,O,$B\GORC,TestIt.rc
12=$.obj,O,$B\NASMW -fobj,$.asm
13=$.exe,O,$B\ALINK -oPE,$.obj,c:\compila\nasmx\lib\win32.lib,TestIt.res
14=0,0,,$.exe
15=rsrc.obj,O,$B\CVTRES,TestIt.res
16=*.obj,O,$B\NASMW -fobj,*.asm
17=0,0,\OllyDbg\OllyDbg,$.exe
[MakeFiles]
0=TestIt.rap
1=TestIt.rc
2=TestIt.asm
3=TestIt.obj
4=TestIt.res
5=TestIt.exe
6=TestIt.def
7=TestIt.dll
8=TestIt.txt
9=TestIt.lib
10=TestIt.mak
[Resource]
[StringTable]
[Accel]
[VerInf]
[Group]
Group=Added files,Assembly,Resources,Misc,Modules
1=2
2=2
3=3
4=3
[*ENDDEF*]
[*BEGINTXT*]
TestIt.Asm
%include 'C:\Compila\NASMX\inc\nasmx.inc'              ; Inclumos macros
%include 'C:\Compila\NASMX\inc\win32\windows.inc'      ; Inclumos definiciones de estructuras y constantes
%include 'C:\Compila\NASMX\inc\win32\kernel32.inc'     ; Importamos las bibliotecas para que el enlazador pueda trabajar
%include 'C:\Compila\NASMX\inc\win32\user32.inc'       ; Importamos las bibliotecas para que el enlazador pueda trabajar

cdXPos      EQU  128         ; Constante double X-Posicin de la ventana(esq sup izqda)
cdYPos      EQU  128         ; Constante double Y-Posicin de la ventana(esq sup izqda)
cdXSize     EQU  320         ; Constante double X-tamao de la ventana
cdYSize     EQU  200         ; Constante double Y-tamao de la ventana
cdColFondo  EQU  COLOR_BTNFACE + 1  ; Color de fondo de la ventana: gris de un botn de comando
cdVIcono    EQU  IDI_APPLICATION ; Icono de la ventana, vase Resource.H
cdVCursor   EQU  IDC_ARROW   ; Cursor para la ventana
; Tipo de ventana (Barra de cabecera)
; cdVBarTipo  EQU  WS_EX_TOOLWINDOW                     ; Tipo de barra de Cabecera: delgado, sin icono, sin reflejo en la barra de tareas
cdVBarTipo  EQU  NULL                                 ; Normal, con icono
cdVBtnTipo  EQU  WS_VISIBLE+WS_DLGFRAME+WS_SYSMENU    ; Normal slo con botn cerrar
; cdVBtnTipo     EQU  WS_OVERLAPPEDWINDOW                ; Normal slo con los tres botones

entry Entrada

[section .text]
  proc    Entrada
    invoke   GetModuleHandleA, dword NULL
    mov      [wc + WNDCLASSEX.hInstance], eax
    INVOKE   GetCommandLineA
    mov      [CommandLine], EAX
    invoke   WinMain, dword wc + WNDCLASSEX.hInstance, dword NULL, dword CommandLine, dword SW_SHOWNORMAL
    invoke   ExitProcess, dword NULL
    ret
  endproc
  
  proc    WinMain
    ;  Propsito: Inicializamos la ventana principal de la aplicacin y captura errores, si los hubiere
    ;  Entrada  : hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    ; Recogemos los parmetros
    hinst    argd        ; Current instance handle - enganche a la instancia actual
    hpinst   argd        ; Previous instance handle- enganche a la instancia previa
    cmdln    argd        ; Command line arguments  - argumentos de la lnea de comandos
    dwshow   argd        ; Display style           - Estilo de despliegue

    invoke   LoadIconA, dword NULL, dword cdVIcono
    mov      edx, eax
    mov      eax, dword argv(hinst)
    mov      ebx, dword NombreClase
    mov      ecx, dword WndProc
;     MOV      [wc + WNDCLASSEX.hbrBackground], dword cdColFondo  ; Color de fondo de la ventana
    mov      [wc + WNDCLASSEX.hInstance], eax
    mov      [wc + WNDCLASSEX.lpszClassName], ebx
    mov      [wc + WNDCLASSEX.lpfnWndProc], ecx
    mov      [wc + WNDCLASSEX.hIcon], edx
    mov      [wc + WNDCLASSEX.hIconSm], edx

    invoke   LoadCursorA, NULL, cdVCursor
    mov      [wc + WNDCLASSEX.hCursor], eax

    invoke   RegisterClassExA, dword wc
    test     eax, eax
    jz       L_Error

   invoke    CreateWindowExA, dword cdVBarTipo, dword NombreClase, dword MsgCabecera, dword cdVBtnTipo,dword cdXPos, dword cdYPos, dword cdXSize, dword cdYSize, dword NULL, dword NULL, dword [wc + WNDCLASSEX.hInstance], dword NULL
    test     eax, eax
    jz       L_Error
    mov      [hWnd], eax

    invoke   ShowWindow, dword hWnd, dword SW_SHOWNORMAL
    invoke   UpdateWindow, dword hWnd

    .msgloop:
        invoke   GetMessageA, dword message, dword NULL, dword NULL, dword NULL
        cmp      eax, dword 0
        je       end_loop
        invoke   TranslateMessage, dword message
        invoke   DispatchMessageA, dword message
    jmp      .msgloop

    L_Error:
      invoke    MessageBoxA, DWORD NULL, DWORD MsgError, NULL, DWORD MB_ICONERROR+MB_OK

    end_loop:

    mov      eax, dword [message + MSG.wParam]
    ret
  endproc

  proc    WndProc
    ;  Propsito: Procesa los mensajes provenientes de las ventanas
    ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    ; Recogemos los parmetros
    hwnd    argd        ; Window handle
    umsg    argd        ; Window message
    wparam  argd        ; wParam
    lparam  argd        ; lParam

    cmp     argv(umsg),dword WM_DESTROY
    je      .wmdestroy
    .defwndproc:
        invoke  DefWindowProcA,dword argv(hwnd), dword argv(umsg), dword argv(wparam), dword argv(lparam)
        jmp     .finish
    .wmdestroy:
        invoke  PostQuitMessage,dword NULL
        xor     eax,eax
    .finish:
    ret
  endproc

[section .bss]
  CommandLine  resd 1
  hWnd:        resd 1

[section .data]
;     szStatic:       db    "STATIC", 0x0
    MsgCabecera:    db    "Nuestra primera ventana (NASM)", 0x0
    NombreClase:    db    "SimpleWinClass", 0x0
    MsgError:       db    "Carga inicial fallida.",0x0
    
    wc:
    istruc WNDCLASSEX
        at WNDCLASSEX.cbSize,          dd    WNDCLASSEX_size
        at WNDCLASSEX.style,           dd    CS_VREDRAW + CS_HREDRAW
        at WNDCLASSEX.lpfnWndProc,     dd    NULL
        at WNDCLASSEX.cbClsExtra,      dd    NULL
        at WNDCLASSEX.cbWndExtra,      dd    NULL
        at WNDCLASSEX.hInstance,       dd    NULL
        at WNDCLASSEX.hIcon,           dd    NULL
        at WNDCLASSEX.hCursor,         dd    NULL
        at WNDCLASSEX.hbrBackground,   dd    cdColFondo
        at WNDCLASSEX.lpszMenuName,    dd    NULL
        at WNDCLASSEX.lpszClassName,   dd    NULL
        at WNDCLASSEX.hIconSm,         dd    NULL
    iend

    message:
    istruc MSG
        at MSG.hwnd,                   dd    NULL
        at MSG.message,                dd    NULL
        at MSG.wParam,                 dd    NULL
        at MSG.lParam,                 dd    NULL
        at MSG.time,                   dd    NULL
        at MSG.pt,                     dd    NULL
    iend

[*ENDTXT*]
[*BEGINTXT*]
TestIt.Inc
[*ENDTXT*]
[*BEGINTXT*]
TestIt.Rc
#include <Res\TestIt.rc>
[*ENDTXT*]
[*BEGINBIN*]
TestIt.dlg
6500000001000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
00000000000000004D532053616E732053657269660000000000000000000000
000000000000000008000000F5FFFFFF00000000E80300000000000000000000
000000000000000097050ABF0000000022030C0001000000EB4D410024030C00
000000000008CF10000000000A0000000A0000002C010000C80000004944445F
444C470000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000001000000494444
5F444C4731000000000000000000000000000000000000000000000000000000
00000000002A030F000000000022F4D57722030C000000000000000150000000
00C30000008A0000004C000000160000004578697400544E0000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000000
0000040000000400000000000000E80300004944435F42544E31000000000000
0000000000000000000000000000000000000000000000000000
[*ENDBIN*]
[*ENDPRO*]
[*BEGINTXT*]
Res\TestIt.Rc
#define IDD_DLG1 1
#define IDC_BTN1 1000
IDD_DLG1 DIALOGEX 6,6,194,106
CAPTION "IDD_DLG"
FONT 8,"MS Sans Serif"
STYLE 0x10CF0800
EXSTYLE 0x00000000
BEGIN
  PUSHBUTTON "Exit",IDC_BTN1,130,84,50,13,NOT 0x00820000|0x50010000,0x00000000
END
[*ENDTXT*]
